import React from 'react';
import { RendererProps } from '../factory';
import { ClassNamesFn } from '../theme';
export interface ImageProps {
    src: string;
    title?: string;
    alt?: string;
    className?: string;
    imageClassName?: string;
    description?: string;
    thumbMode?: 'w-full' | 'h-full' | 'contain' | 'cover';
    thumbRatio?: '1-1' | '4-3' | '16-9';
    classnames: ClassNamesFn;
    classPrefix: string;
    onLoad?: React.EventHandler<any>;
}
export declare class Image extends React.Component<ImageProps> {
    render(): JSX.Element;
}
declare const ThemedImage: React.ComponentClass<Pick<ImageProps, "title" | "className" | "description" | "alt" | "src" | "onLoad" | "imageClassName" | "thumbMode" | "thumbRatio"> & {
    theme?: string | undefined;
    classPrefix?: string | undefined;
    classnames?: ClassNamesFn | undefined;
}, any> & {
    ComposedComponent: typeof Image;
};
export default ThemedImage;
export interface ImageFieldProps extends RendererProps {
    className?: string;
    imageClassName?: string;
    placeholder: string;
    description?: string;
    thumbMode: 'w-full' | 'h-full' | 'contain' | 'cover';
    thumbRatio: '1-1' | '4-3' | '16-9';
}
export declare class ImageField extends React.Component<ImageFieldProps, object> {
    static defaultProps: Pick<ImageFieldProps, 'defaultImage' | 'thumbMode' | 'thumbRatio' | 'placeholder'>;
    render(): JSX.Element;
}
export declare class ImageFieldRenderer extends ImageField {
}
